-- This is for if characters add something to a monitor.
-- Like Yoshi getting an egg from a ring monitor, for example.
-- And also if they have a sprite for it.

local function characterMonitor(monitor)
	-- Get playr info
	for player in players.iterate
		-- If player's skin is a character with Ringbox stuff
		if player.mo.skin == "yoshi"
		or player.mo.skin == "joshi"
			-- Change ring box's states
			states[S_RING_BOX] = {SPR_VTYE, A|FF_PAPERSPRITE, 1, nil, 0, 0, S_BOX_FLICKER}
			states[S_RING_ICON1] = {SPR_VTYE, C|FF_ANIMATE, 18, A_MonitorPop, 3, 4, S_RING_ICON2}
			states[S_RING_ICON2] = {SPR_VTYE, C, 18, A_RingBox, 0, 0, S_NULL}
		elseif player.mo.skin == "pacman"
		and player.pachealth == true
			states[S_RING_BOX] = {SPR_VTPM, A|FF_PAPERSPRITE, 1, nil, 0, 0, S_BOX_FLICKER}
			states[S_RING_ICON1] = {SPR_VTPM, C|FF_ANIMATE, 18, A_MonitorPop, 3, 4, S_RING_ICON2}
			states[S_RING_ICON2] = {SPR_VTPM, C, 18, A_RingBox, 0, 0, S_NULL}
			-- Reset them to normal (if these are the vanilla values)
		else
			states[S_RING_BOX] = {SPR_VTRI, A|FF_PAPERSPRITE, 1, nil, 0, 0, S_BOX_FLICKER}
			states[S_RING_ICON1] = {SPR_TVRI, 2|FF_ANIMATE, 18, A_MonitorPop, 3, 4, S_RING_ICON2}
			states[S_RING_ICON2] = {SPR_TVRI, 2, 18, A_RingBox, 0, 0, S_NULL}
		end	
	end
end

-- Always put this at the bottom.
-- Dont try to load functions before they exist lmao
for i = 1, #mobjinfo-1
    if mobjinfo[i].flags & MF_MONITOR		
        addHook("MobjThinker", characterMonitor, i)
	end
end