-- Pardon the unprofessional code, but it works LMAO

freeslot(
"MT_FAKEBOX_TOP","S_FAKEBOX_TOP",
"MT_FAKEBOX_BOTTOM","S_FAKEBOX_BOTTOM",
"SPR_GMTV")

-- Fake Freeslots because otherwise it all shatters
-- Currently unsure how to check for things that do not exist.
-- The table cannot check an object that does not exist,
-- so if we check for mod monitors without the mod added,
-- the table tries to check for something that does not exist
-- and therefore explodes.

-- ShieldsPlus
freeslot("MT_ICESHIELD_GOLDBOX", "MT_HOVERSHIELD_GOLDBOX", "MT_METALSHIELD_GOLDBOX",
"MT_SPIKESHIELD_GOLDBOX", "MT_BUMPERSHIELD_GOLDBOX", "MT_MOMENTUMSHIELD_GOLDBOX")

-- Rock Shield
freeslot("MT_ROCKSHIELD_GOLDBOX")

-- Set up fakebox parts
mobjinfo[MT_FAKEBOX_TOP] = {spawnstate = S_FAKEBOX_TOP, flags = MF_NOTHINK}
mobjinfo[MT_FAKEBOX_BOTTOM] = {spawnstate = S_FAKEBOX_BOTTOM, flags = MF_NOTHINK}
states[S_FAKEBOX_TOP] = {sprite = SPR_MSVT, frame = 0}
states[S_FAKEBOX_BOTTOM] = {sprite = SPR_MSVT, frame = 1}

-- LJ Sonic's Table thing
-- If the object is a gold monitor, it returns true
local goldMonitors = {
	-- Vanilla
    [MT_PITY_GOLDBOX] = true,
    [MT_ATTRACT_GOLDBOX] = true,
    [MT_FORCE_GOLDBOX] = true,
    [MT_ARMAGEDDON_GOLDBOX] = true,
    [MT_WHIRLWIND_GOLDBOX] = true,
    [MT_ELEMENTAL_GOLDBOX] = true,
    [MT_SNEAKERS_GOLDBOX] = true,
    [MT_INVULN_GOLDBOX] = true,
    [MT_EGGMAN_GOLDBOX] = true,
    [MT_GRAVITY_GOLDBOX] = true,
    [MT_FLAMEAURA_GOLDBOX] = true,
    [MT_BUBBLEWRAP_GOLDBOX] = true,
    [MT_THUNDERCOIN_GOLDBOX] = true,
	-- ShieldsPlus
	[MT_ICESHIELD_GOLDBOX] = true,
	[MT_HOVERSHIELD_GOLDBOX] = true,
	[MT_METALSHIELD_GOLDBOX] = true,
	[MT_SPIKESHIELD_GOLDBOX] = true,
	[MT_BUMPERSHIELD_GOLDBOX] = true,
	[MT_MOMENTUMSHIELD_GOLDBOX] = true,
	-- Rock Shield
	[MT_ROCKSHIELD_GOLDBOX] = true,
}

-- Returns "true" if any mobj is in the table
local function isGoldenMonitor(mobj)
    return goldMonitors[mobj.type] == true
end

-- Resizing monitors and changing their height to match sprites.
-- This is funky for monitors in small areas
-- Also breaks that monitor conveyer in THZ :<
for i = 1, #mobjinfo-1
    if mobjinfo[i].flags & MF_MONITOR
        addHook("MobjThinker", function(monitor)
			if monitor.valid
				if (monitor.scale ~= FixedDiv(4*FRACUNIT, 5*FRACUNIT))
					P_SetScale(monitor, FixedDiv(4*FRACUNIT, 5*FRACUNIT))
					monitor.height = 50*FRACUNIT
				end
			end
        end, i)
    end
	-- Also the box icons
	if mobjinfo[i].flags & MF_BOXICON
		addHook("MobjThinker", function(boxIcon)
			if (boxIcon.scale ~= FixedDiv(4*FRACUNIT, 5*FRACUNIT))
				P_SetScale(boxIcon, FixedDiv(4*FRACUNIT, 5*FRACUNIT))
			end
		end, i)
	end
end

-- Fake item box function.
-- Spawns a fake item box using the monitor's main sprite
-- while keeping S_BOX_FLICKER's duration set to 0.
local function monitorThinker(monitor)
	if monitor.valid
		if monitor.mobjspawned == nil
			monitor.mobjspawned = 0
		end
	end
	-- Setup Monitor tops and bottoms
	if monitor.valid
	and monitor.mobjspawned == 0
		local fakeboxtop = P_SpawnMobj(monitor.x, monitor.y, monitor.z, MT_FAKEBOX_TOP)
		local fakeboxbottom = P_SpawnMobj(monitor.x, monitor.y, monitor.z, MT_FAKEBOX_BOTTOM)
		if monitor.type == MT_RING_REDBOX
			fakeboxtop.sprite = SPR_VRRI
			fakeboxtop.frame = 1
			fakeboxbottom.sprite = SPR_VRRI
			fakeboxbottom.frame = 2
		elseif monitor.type == MT_RING_BLUEBOX
			fakeboxtop.sprite = SPR_VBRI
			fakeboxtop.frame = 1
			fakeboxbottom.sprite = SPR_VBRI
			fakeboxbottom.frame = 2
		-- If a gold monitor, be G O L D
		elseif goldMonitors[monitor.type] == true
			fakeboxtop.sprite = SPR_GMTV
			fakeboxtop.frame = 0
			fakeboxbottom.sprite = SPR_GMTV
			fakeboxbottom.frame = 1
			monitor.flags = $1 & ~MF_SOLID
		else
			fakeboxtop.sprite = SPR_MSVT
			fakeboxtop.frame = 0
			fakeboxbottom.sprite = SPR_MSVT
			fakeboxbottom.frame = 1
		end
		-- Scale them
		fakeboxtop.scale = monitor.scale
		fakeboxbottom.scale = monitor.scale
		monitor.faketop = fakeboxtop
		monitor.fakebottom = fakeboxbottom
		monitor.mobjspawned = 1
	end
	-- Setup angle rotation
	if monitor.valid
		if monitor.angleRotation == nil
			monitor.angleRotation = 0
		end
	end
	-- Rotate it
	if monitor.valid
		monitor.angleRotation = ($ + 8) % 360
		monitor.angle = FixedAngle(monitor.angleRotation*FRACUNIT)
	end
	-- VerticalFlip flags
	-- If verticalflip, give the fakeboxes verticalflip
	-- Vertical flipped monitors get very excited
	if monitor.valid
		if monitor.faketop and monitor.faketop.valid
		and monitor.fakebottom and monitor.fakebottom.valid
			if monitor.eflags & MFE_VERTICALFLIP
				monitor.faketop.eflags = $1 | MFE_VERTICALFLIP
				monitor.fakebottom.eflags = $1 | MFE_VERTICALFLIP
				if monitor.goldfaketop and monitor.goldfaketop.valid
				and monitor.goldfakebottom and monitor.goldfakebottom.valid
					monitor.goldfaketop.eflags = $1 | MFE_VERTICALFLIP
					monitor.goldfakebottom.eflags = $1 | MFE_VERTICALFLIP
				end
			else
				monitor.faketop.eflags = $1 & ~MFE_VERTICALFLIP
				monitor.fakebottom.eflags = $1 & ~MFE_VERTICALFLIP
				if monitor.goldfaketop and monitor.goldfaketop.valid
				and monitor.goldfakebottom and monitor.goldfakebottom.valid
					monitor.goldfaketop.eflags = $1 & ~MFE_VERTICALFLIP
					monitor.goldfakebottom.eflags = $1 & ~MFE_VERTICALFLIP
				end
			end
		end
	end
	
	-- Teleport the monitor objects to the real monitor
	-- To make sure that they are at exactly where the real monitors are,
	-- we need to do this constantly, for all pieces of the fake monitor.
	if monitor.valid 
	and monitor.eflags & MFE_VERTICALFLIP
		if monitor.faketop and monitor.faketop.valid
			P_TeleportMove(monitor.faketop, monitor.x, monitor.y, (monitor.z + monitor.height))
		end
		if monitor.fakebottom and monitor.fakebottom.valid
			P_TeleportMove(monitor.fakebottom, monitor.x, monitor.y, (monitor.z + monitor.height))
		end
		if monitor.goldfaketop and monitor.goldfaketop.valid
			P_TeleportMove(monitor.goldfaketop, monitor.x, monitor.y, (monitor.z + monitor.height))
		end
		if monitor.goldfakebottom and monitor.goldfakebottom.valid
			P_TeleportMove(monitor.goldfakebottom, monitor.x, monitor.y, (monitor.z + monitor.height))
		end
	elseif monitor.valid
		if monitor.faketop and monitor.faketop.valid
			P_TeleportMove(monitor.faketop, monitor.x, monitor.y, monitor.z)
		end
		if monitor.fakebottom and monitor.fakebottom.valid
			P_TeleportMove(monitor.fakebottom, monitor.x, monitor.y, monitor.z)
		end
		if monitor.goldfaketop and monitor.goldfaketop.valid
			P_TeleportMove(monitor.goldfaketop, monitor.x, monitor.y, monitor.z)
		end
		if monitor.goldfakebottom and monitor.goldfakebottom.valid
			P_TeleportMove(monitor.goldfakebottom, monitor.x, monitor.y, monitor.z)
		end
	end
end

-- Add hook for ONLY MONITORS
for i = 1, #mobjinfo-1
    if mobjinfo[i].flags & MF_MONITOR		
        addHook("MobjThinker", monitorThinker, i)
	end
end